"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LemmyHttp = void 0;
var node_fetch_1 = require("node-fetch");
var HttpType;
(function (HttpType) {
    HttpType["Get"] = "GET";
    HttpType["Post"] = "POST";
    HttpType["Put"] = "PUT";
})(HttpType || (HttpType = {}));
var LemmyHttp = /** @class */ (function () {
    function LemmyHttp(baseUrl, headers) {
        this.headers = {};
        this.baseUrl = baseUrl;
        if (headers) {
            this.headers = headers;
        }
    }
    LemmyHttp.prototype.getSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/site', form)];
            });
        });
    };
    LemmyHttp.prototype.createSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/site', form)];
            });
        });
    };
    LemmyHttp.prototype.editSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/site', form)];
            });
        });
    };
    LemmyHttp.prototype.transferSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/site/transfer', form)];
            });
        });
    };
    LemmyHttp.prototype.getSiteConfig = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/site/config', form)];
            });
        });
    };
    LemmyHttp.prototype.saveSiteConfig = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/site/config', form)];
            });
        });
    };
    LemmyHttp.prototype.listCategories = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/categories', {})];
            });
        });
    };
    LemmyHttp.prototype.getModlog = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/modlog', form)];
            });
        });
    };
    LemmyHttp.prototype.search = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/search', form)];
            });
        });
    };
    LemmyHttp.prototype.createCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community', form)];
            });
        });
    };
    LemmyHttp.prototype.getCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/community', form)];
            });
        });
    };
    LemmyHttp.prototype.editCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/community', form)];
            });
        });
    };
    LemmyHttp.prototype.listCommunities = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/community/list', form)];
            });
        });
    };
    LemmyHttp.prototype.followCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/follow', form)];
            });
        });
    };
    LemmyHttp.prototype.deleteCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/delete', form)];
            });
        });
    };
    LemmyHttp.prototype.removeCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/remove', form)];
            });
        });
    };
    LemmyHttp.prototype.transferCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/transfer', form)];
            });
        });
    };
    LemmyHttp.prototype.banFromCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/ban_user', form)];
            });
        });
    };
    LemmyHttp.prototype.addModToCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/mod', form)];
            });
        });
    };
    LemmyHttp.prototype.createPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post', form)];
            });
        });
    };
    LemmyHttp.prototype.getPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/post', form)];
            });
        });
    };
    LemmyHttp.prototype.editPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/post', form)];
            });
        });
    };
    LemmyHttp.prototype.deletePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post/delete', form)];
            });
        });
    };
    LemmyHttp.prototype.removePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post/remove', form)];
            });
        });
    };
    LemmyHttp.prototype.lockPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post/lock', form)];
            });
        });
    };
    LemmyHttp.prototype.stickyPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post/sticky', form)];
            });
        });
    };
    LemmyHttp.prototype.getPosts = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/post/list', form)];
            });
        });
    };
    LemmyHttp.prototype.likePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post/like', form)];
            });
        });
    };
    LemmyHttp.prototype.savePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/post/save', form)];
            });
        });
    };
    LemmyHttp.prototype.createComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/comment', form)];
            });
        });
    };
    LemmyHttp.prototype.editComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/comment', form)];
            });
        });
    };
    LemmyHttp.prototype.deleteComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/comment/delete', form)];
            });
        });
    };
    LemmyHttp.prototype.removeComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/comment/remove', form)];
            });
        });
    };
    LemmyHttp.prototype.markCommentAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/comment/mark_as_read', form)];
            });
        });
    };
    LemmyHttp.prototype.likeComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/comment/like', form)];
            });
        });
    };
    LemmyHttp.prototype.saveComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/comment/save', form)];
            });
        });
    };
    LemmyHttp.prototype.getComments = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/comment/list', form)];
            });
        });
    };
    LemmyHttp.prototype.getPrivateMessages = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/private_message/list', form)];
            });
        });
    };
    LemmyHttp.prototype.createPrivateMessage = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/private_message', form)];
            });
        });
    };
    LemmyHttp.prototype.editPrivateMessage = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/private_message', form)];
            });
        });
    };
    LemmyHttp.prototype.deletePrivateMessage = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/private_message/delete', form)];
            });
        });
    };
    LemmyHttp.prototype.markPrivateMessageAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/private_message/mark_as_read', form)];
            });
        });
    };
    LemmyHttp.prototype.register = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/register', form)];
            });
        });
    };
    LemmyHttp.prototype.login = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/login', form)];
            });
        });
    };
    LemmyHttp.prototype.getUserDetails = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/user', form)];
            });
        });
    };
    LemmyHttp.prototype.getUserMentions = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/user/mention', form)];
            });
        });
    };
    LemmyHttp.prototype.markUserMentionAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/mention/mark_as_read', form)];
            });
        });
    };
    LemmyHttp.prototype.getReplies = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/user/replies', form)];
            });
        });
    };
    LemmyHttp.prototype.getFollowedCommunities = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/user/followed_communities', form)];
            });
        });
    };
    LemmyHttp.prototype.userJoin = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/join', form)];
            });
        });
    };
    LemmyHttp.prototype.postJoin = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/post/join', form)];
            });
        });
    };
    LemmyHttp.prototype.communityJoin = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/community/join', form)];
            });
        });
    };
    LemmyHttp.prototype.banUser = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/ban', form)];
            });
        });
    };
    LemmyHttp.prototype.getCaptcha = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, '/user/get_captcha', {})];
            });
        });
    };
    LemmyHttp.prototype.deleteAccount = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/delete_account', form)];
            });
        });
    };
    LemmyHttp.prototype.passwordReset = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/password_reset', form)];
            });
        });
    };
    LemmyHttp.prototype.passwordChange = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/password_change', form)];
            });
        });
    };
    LemmyHttp.prototype.markAllAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/user/mark_all_as_read', form)];
            });
        });
    };
    LemmyHttp.prototype.saveUserSettings = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, '/user/save_user_settings', form)];
            });
        });
    };
    LemmyHttp.prototype.addAdmin = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, '/admin/add', form)];
            });
        });
    };
    LemmyHttp.prototype.buildFullUrl = function (endpoint) {
        return "" + this.baseUrl + endpoint;
    };
    LemmyHttp.prototype.wrapper = function (type_, endpoint, form) {
        return __awaiter(this, void 0, void 0, function () {
            var getUrl;
            return __generator(this, function (_a) {
                if (type_ == HttpType.Get) {
                    getUrl = this.buildFullUrl(endpoint) + "?" + encodeGetParams(form);
                    return [2 /*return*/, node_fetch_1.default(getUrl, {
                            method: 'GET',
                            headers: this.headers,
                        }).then(function (d) { return d.json(); })];
                }
                else {
                    return [2 /*return*/, node_fetch_1.default(this.buildFullUrl(endpoint), {
                            method: type_,
                            headers: __assign({ 'Content-Type': 'application/json' }, this.headers),
                            body: JSON.stringify(form),
                        }).then(function (d) { return d.json(); })];
                }
                return [2 /*return*/];
            });
        });
    };
    return LemmyHttp;
}());
exports.LemmyHttp = LemmyHttp;
function encodeGetParams(p) {
    return Object.entries(p)
        .map(function (kv) { return kv.map(encodeURIComponent).join('='); })
        .join('&');
}
