import { CommentReportView, CommentView } from '../views';
export interface CreateComment {
    content: string;
    parent_id?: number;
    post_id: number;
    form_id?: string;
    auth: string;
}
export interface EditComment {
    content: string;
    edit_id: number;
    form_id?: string;
    auth: string;
}
export interface DeleteComment {
    edit_id: number;
    deleted: boolean;
    auth: string;
}
export interface RemoveComment {
    edit_id: number;
    removed: boolean;
    reason?: string;
    auth: string;
}
export interface MarkCommentAsRead {
    comment_id: number;
    read: boolean;
    auth: string;
}
export interface SaveComment {
    comment_id: number;
    save: boolean;
    auth: string;
}
export interface CommentResponse {
    comment_view: CommentView;
    recipient_ids: number[];
    form_id?: string;
}
export interface CreateCommentLike {
    comment_id: number;
    score: number;
    auth: string;
}
export interface GetComments {
    type_: string;
    sort: string;
    page?: number;
    limit?: number;
    community_id?: number;
    community_name?: string;
    auth?: string;
}
export interface GetCommentsResponse {
    comments: CommentView[];
}
export interface CreateCommentReport {
    comment_id: number;
    reason: string;
    auth: string;
}
export interface CreateCommentReportResponse {
    success: boolean;
}
export interface ResolveCommentReport {
    report_id: number;
    resolved: boolean;
    auth: string;
}
export interface ResolveCommentReportResponse {
    report_id: number;
    resolved: boolean;
}
export interface ListCommentReports {
    page?: number;
    limit?: number;
    community?: number;
    auth: string;
}
export interface ListCommentReportsResponse {
    comments: CommentReportView[];
}
