export declare enum UserOperation {
    Login = 0,
    Register = 1,
    GetCaptcha = 2,
    CreateCommunity = 3,
    CreatePost = 4,
    ListCommunities = 5,
    ListCategories = 6,
    GetPost = 7,
    GetCommunity = 8,
    CreateComment = 9,
    EditComment = 10,
    DeleteComment = 11,
    RemoveComment = 12,
    MarkCommentAsRead = 13,
    SaveComment = 14,
    CreateCommentLike = 15,
    GetPosts = 16,
    CreatePostLike = 17,
    EditPost = 18,
    DeletePost = 19,
    RemovePost = 20,
    LockPost = 21,
    StickyPost = 22,
    SavePost = 23,
    EditCommunity = 24,
    DeleteCommunity = 25,
    RemoveCommunity = 26,
    FollowCommunity = 27,
    GetFollowedCommunities = 28,
    GetUserDetails = 29,
    GetReplies = 30,
    GetUserMentions = 31,
    MarkUserMentionAsRead = 32,
    GetModlog = 33,
    BanFromCommunity = 34,
    AddModToCommunity = 35,
    CreateSite = 36,
    EditSite = 37,
    GetSite = 38,
    AddAdmin = 39,
    BanUser = 40,
    Search = 41,
    MarkAllAsRead = 42,
    SaveUserSettings = 43,
    TransferCommunity = 44,
    TransferSite = 45,
    DeleteAccount = 46,
    PasswordReset = 47,
    PasswordChange = 48,
    CreatePrivateMessage = 49,
    EditPrivateMessage = 50,
    DeletePrivateMessage = 51,
    MarkPrivateMessageAsRead = 52,
    GetPrivateMessages = 53,
    UserJoin = 54,
    GetComments = 55,
    GetSiteConfig = 56,
    SaveSiteConfig = 57,
    PostJoin = 58,
    CommunityJoin = 59
}
export declare enum SortType {
    Active = "Active",
    Hot = "Hot",
    New = "New",
    TopDay = "TopDay",
    TopWeek = "TopWeek",
    TopMonth = "TopMonth",
    TopYear = "TopYear",
    TopAll = "TopAll"
}
export declare enum ListingType {
    All = "All",
    Local = "Local",
    Subscribed = "Subscribed",
    Community = "Community"
}
export declare enum SearchType {
    All = "All",
    Comments = "Comments",
    Posts = "Posts",
    Communities = "Communities",
    Users = "Users",
    Url = "Url"
}
export interface WebSocketResponse<ResponseType> {
    op: UserOperation;
    data: ResponseType;
}
export interface WebSocketJsonResponse<ResponseType> {
    op?: string;
    data?: ResponseType;
    error?: string;
    reconnect?: boolean;
}
