import { CreateComment, CreateCommentLike, DeleteComment, EditComment, GetComments, MarkCommentAsRead, RemoveComment, SaveComment } from './interfaces/api/comment';
import { AddModToCommunity, BanFromCommunity, CommunityJoin, CreateCommunity, DeleteCommunity, EditCommunity, FollowCommunity, GetCommunity, GetFollowedCommunities, ListCommunities, RemoveCommunity, TransferCommunity } from './interfaces/api/community';
import { CreatePost, CreatePostLike, DeletePost, EditPost, GetPost, GetPosts, LockPost, PostJoin, RemovePost, SavePost, StickyPost } from './interfaces/api/post';
import { CreateSite, EditSite, GetModlog, GetSite, GetSiteConfig, SaveSiteConfig, Search, TransferSite } from './interfaces/api/site';
import { AddAdmin, BanUser, CreatePrivateMessage, DeleteAccount, DeletePrivateMessage, EditPrivateMessage, GetPrivateMessages, GetReplies, GetUserDetails, GetUserMentions, Login, MarkAllAsRead, MarkPrivateMessageAsRead, MarkUserMentionAsRead, PasswordChange, PasswordReset, Register, SaveUserSettings, UserJoin } from './interfaces/api/user';
export declare class LemmyWebsocket {
    constructor();
    login(form: Login): string;
    userJoin(form: UserJoin): string;
    postJoin(form: PostJoin): string;
    communityJoin(form: CommunityJoin): string;
    register(register: Register): string;
    getCaptcha(): string;
    createCommunity(form: CreateCommunity): string;
    editCommunity(form: EditCommunity): string;
    deleteCommunity(form: DeleteCommunity): string;
    removeCommunity(form: RemoveCommunity): string;
    followCommunity(form: FollowCommunity): string;
    listCommunities(form: ListCommunities): string;
    getFollowedCommunities(form: GetFollowedCommunities): string;
    listCategories(): string;
    createPost(form: CreatePost): string;
    getPost(form: GetPost): string;
    getCommunity(form: GetCommunity): string;
    createComment(form: CreateComment): string;
    editComment(form: EditComment): string;
    deleteComment(form: DeleteComment): string;
    removeComment(form: RemoveComment): string;
    markCommentAsRead(form: MarkCommentAsRead): string;
    likeComment(form: CreateCommentLike): string;
    saveComment(form: SaveComment): string;
    getPosts(form: GetPosts): string;
    getComments(form: GetComments): string;
    likePost(form: CreatePostLike): string;
    editPost(form: EditPost): string;
    deletePost(form: DeletePost): string;
    removePost(form: RemovePost): string;
    lockPost(form: LockPost): string;
    stickyPost(form: StickyPost): string;
    savePost(form: SavePost): string;
    banFromCommunity(form: BanFromCommunity): string;
    addModToCommunity(form: AddModToCommunity): string;
    transferCommunity(form: TransferCommunity): string;
    transferSite(form: TransferSite): string;
    banUser(form: BanUser): string;
    addAdmin(form: AddAdmin): string;
    getUserDetails(form: GetUserDetails): string;
    getReplies(form: GetReplies): string;
    getUserMentions(form: GetUserMentions): string;
    markUserMentionAsRead(form: MarkUserMentionAsRead): string;
    getModlog(form: GetModlog): string;
    createSite(form: CreateSite): string;
    editSite(form: EditSite): string;
    getSite(form?: GetSite): string;
    getSiteConfig(form: GetSiteConfig): string;
    search(form: Search): string;
    markAllAsRead(form: MarkAllAsRead): string;
    saveUserSettings(form: SaveUserSettings): string;
    deleteAccount(form: DeleteAccount): string;
    passwordReset(form: PasswordReset): string;
    passwordChange(form: PasswordChange): string;
    createPrivateMessage(form: CreatePrivateMessage): string;
    editPrivateMessage(form: EditPrivateMessage): string;
    deletePrivateMessage(form: DeletePrivateMessage): string;
    markPrivateMessageAsRead(form: MarkPrivateMessageAsRead): string;
    getPrivateMessages(form: GetPrivateMessages): string;
    saveSiteConfig(form: SaveSiteConfig): string;
}
