"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LemmyWebsocket = void 0;
var others_1 = require("./interfaces/others");
var LemmyWebsocket = /** @class */ (function () {
    function LemmyWebsocket() {
    }
    LemmyWebsocket.prototype.login = function (form) {
        return wrapper(others_1.UserOperation.Login, form);
    };
    LemmyWebsocket.prototype.userJoin = function (form) {
        return wrapper(others_1.UserOperation.UserJoin, form);
    };
    LemmyWebsocket.prototype.postJoin = function (form) {
        return wrapper(others_1.UserOperation.PostJoin, form);
    };
    LemmyWebsocket.prototype.communityJoin = function (form) {
        return wrapper(others_1.UserOperation.CommunityJoin, form);
    };
    LemmyWebsocket.prototype.register = function (register) {
        return wrapper(others_1.UserOperation.Register, register);
    };
    LemmyWebsocket.prototype.getCaptcha = function () {
        return wrapper(others_1.UserOperation.GetCaptcha, {});
    };
    LemmyWebsocket.prototype.createCommunity = function (form) {
        return wrapper(others_1.UserOperation.CreateCommunity, form);
    };
    LemmyWebsocket.prototype.editCommunity = function (form) {
        return wrapper(others_1.UserOperation.EditCommunity, form);
    };
    LemmyWebsocket.prototype.deleteCommunity = function (form) {
        return wrapper(others_1.UserOperation.DeleteCommunity, form);
    };
    LemmyWebsocket.prototype.removeCommunity = function (form) {
        return wrapper(others_1.UserOperation.RemoveCommunity, form);
    };
    LemmyWebsocket.prototype.followCommunity = function (form) {
        return wrapper(others_1.UserOperation.FollowCommunity, form);
    };
    LemmyWebsocket.prototype.listCommunities = function (form) {
        return wrapper(others_1.UserOperation.ListCommunities, form);
    };
    LemmyWebsocket.prototype.getFollowedCommunities = function (form) {
        return wrapper(others_1.UserOperation.GetFollowedCommunities, form);
    };
    LemmyWebsocket.prototype.listCategories = function () {
        return wrapper(others_1.UserOperation.ListCategories, {});
    };
    LemmyWebsocket.prototype.createPost = function (form) {
        return wrapper(others_1.UserOperation.CreatePost, form);
    };
    LemmyWebsocket.prototype.getPost = function (form) {
        return wrapper(others_1.UserOperation.GetPost, form);
    };
    LemmyWebsocket.prototype.getCommunity = function (form) {
        return wrapper(others_1.UserOperation.GetCommunity, form);
    };
    LemmyWebsocket.prototype.createComment = function (form) {
        return wrapper(others_1.UserOperation.CreateComment, form);
    };
    LemmyWebsocket.prototype.editComment = function (form) {
        return wrapper(others_1.UserOperation.EditComment, form);
    };
    LemmyWebsocket.prototype.deleteComment = function (form) {
        return wrapper(others_1.UserOperation.DeleteComment, form);
    };
    LemmyWebsocket.prototype.removeComment = function (form) {
        return wrapper(others_1.UserOperation.RemoveComment, form);
    };
    LemmyWebsocket.prototype.markCommentAsRead = function (form) {
        return wrapper(others_1.UserOperation.MarkCommentAsRead, form);
    };
    LemmyWebsocket.prototype.likeComment = function (form) {
        return wrapper(others_1.UserOperation.CreateCommentLike, form);
    };
    LemmyWebsocket.prototype.saveComment = function (form) {
        return wrapper(others_1.UserOperation.SaveComment, form);
    };
    LemmyWebsocket.prototype.getPosts = function (form) {
        return wrapper(others_1.UserOperation.GetPosts, form);
    };
    LemmyWebsocket.prototype.getComments = function (form) {
        return wrapper(others_1.UserOperation.GetComments, form);
    };
    LemmyWebsocket.prototype.likePost = function (form) {
        return wrapper(others_1.UserOperation.CreatePostLike, form);
    };
    LemmyWebsocket.prototype.editPost = function (form) {
        return wrapper(others_1.UserOperation.EditPost, form);
    };
    LemmyWebsocket.prototype.deletePost = function (form) {
        return wrapper(others_1.UserOperation.DeletePost, form);
    };
    LemmyWebsocket.prototype.removePost = function (form) {
        return wrapper(others_1.UserOperation.RemovePost, form);
    };
    LemmyWebsocket.prototype.lockPost = function (form) {
        return wrapper(others_1.UserOperation.LockPost, form);
    };
    LemmyWebsocket.prototype.stickyPost = function (form) {
        return wrapper(others_1.UserOperation.StickyPost, form);
    };
    LemmyWebsocket.prototype.savePost = function (form) {
        return wrapper(others_1.UserOperation.SavePost, form);
    };
    LemmyWebsocket.prototype.banFromCommunity = function (form) {
        return wrapper(others_1.UserOperation.BanFromCommunity, form);
    };
    LemmyWebsocket.prototype.addModToCommunity = function (form) {
        return wrapper(others_1.UserOperation.AddModToCommunity, form);
    };
    LemmyWebsocket.prototype.transferCommunity = function (form) {
        return wrapper(others_1.UserOperation.TransferCommunity, form);
    };
    LemmyWebsocket.prototype.transferSite = function (form) {
        return wrapper(others_1.UserOperation.TransferSite, form);
    };
    LemmyWebsocket.prototype.banUser = function (form) {
        return wrapper(others_1.UserOperation.BanUser, form);
    };
    LemmyWebsocket.prototype.addAdmin = function (form) {
        return wrapper(others_1.UserOperation.AddAdmin, form);
    };
    LemmyWebsocket.prototype.getUserDetails = function (form) {
        return wrapper(others_1.UserOperation.GetUserDetails, form);
    };
    LemmyWebsocket.prototype.getReplies = function (form) {
        return wrapper(others_1.UserOperation.GetReplies, form);
    };
    LemmyWebsocket.prototype.getUserMentions = function (form) {
        return wrapper(others_1.UserOperation.GetUserMentions, form);
    };
    LemmyWebsocket.prototype.markUserMentionAsRead = function (form) {
        return wrapper(others_1.UserOperation.MarkUserMentionAsRead, form);
    };
    LemmyWebsocket.prototype.getModlog = function (form) {
        return wrapper(others_1.UserOperation.GetModlog, form);
    };
    LemmyWebsocket.prototype.createSite = function (form) {
        return wrapper(others_1.UserOperation.CreateSite, form);
    };
    LemmyWebsocket.prototype.editSite = function (form) {
        return wrapper(others_1.UserOperation.EditSite, form);
    };
    LemmyWebsocket.prototype.getSite = function (form) {
        if (form === void 0) { form = {}; }
        return wrapper(others_1.UserOperation.GetSite, form);
    };
    LemmyWebsocket.prototype.getSiteConfig = function (form) {
        return wrapper(others_1.UserOperation.GetSiteConfig, form);
    };
    LemmyWebsocket.prototype.search = function (form) {
        return wrapper(others_1.UserOperation.Search, form);
    };
    LemmyWebsocket.prototype.markAllAsRead = function (form) {
        return wrapper(others_1.UserOperation.MarkAllAsRead, form);
    };
    LemmyWebsocket.prototype.saveUserSettings = function (form) {
        return wrapper(others_1.UserOperation.SaveUserSettings, form);
    };
    LemmyWebsocket.prototype.deleteAccount = function (form) {
        return wrapper(others_1.UserOperation.DeleteAccount, form);
    };
    LemmyWebsocket.prototype.passwordReset = function (form) {
        return wrapper(others_1.UserOperation.PasswordReset, form);
    };
    LemmyWebsocket.prototype.passwordChange = function (form) {
        return wrapper(others_1.UserOperation.PasswordChange, form);
    };
    LemmyWebsocket.prototype.createPrivateMessage = function (form) {
        return wrapper(others_1.UserOperation.CreatePrivateMessage, form);
    };
    LemmyWebsocket.prototype.editPrivateMessage = function (form) {
        return wrapper(others_1.UserOperation.EditPrivateMessage, form);
    };
    LemmyWebsocket.prototype.deletePrivateMessage = function (form) {
        return wrapper(others_1.UserOperation.DeletePrivateMessage, form);
    };
    LemmyWebsocket.prototype.markPrivateMessageAsRead = function (form) {
        return wrapper(others_1.UserOperation.MarkPrivateMessageAsRead, form);
    };
    LemmyWebsocket.prototype.getPrivateMessages = function (form) {
        return wrapper(others_1.UserOperation.GetPrivateMessages, form);
    };
    LemmyWebsocket.prototype.saveSiteConfig = function (form) {
        return wrapper(others_1.UserOperation.SaveSiteConfig, form);
    };
    return LemmyWebsocket;
}());
exports.LemmyWebsocket = LemmyWebsocket;
function wrapper(op, data) {
    var send = { op: others_1.UserOperation[op], data: data };
    console.log(send);
    return JSON.stringify(send);
}
